//******************************************************************
//
//	MP3 player kit BK1 Boot Loader
//
//	2008.7.21	SPI Mode 0
//	2007.3.20	KAWAKAMI Yukio
//
//******************************************************************

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;

struct FDATE {
	unsigned short	ft_day	 : 5;
	unsigned short	ft_month : 4;
	unsigned short	ft_year	 : 7;
};

struct FTIME {
	unsigned short	ft_sec	: 5;
	unsigned short	ft_min	: 6;
	unsigned short	ft_hour	: 5;
};

struct DIRECTORY {
	uchar	filename[8];
	uchar	ext[3];
	uchar	att;
	uchar	not_use[10];
	struct FTIME	time;
	struct FDATE	date;
	unsigned short	cluster;
	ulong	size;
};

struct FILE_DATA {
	ulong	sec;
	uint	sc;
	uint	cluster;
	ushort	size;
	ushort	p;
};

#define		FAT12		1
#define		FAT16		2

#define		ON	1
#define		OFF	0
#define		TRUE	1
#define		FALSE	0

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)


#define		MP3_DATA_CS	0	// PORTB
#define		MP3_CTRL_CS	1

#define		MP3_RESET	2	// PORTC
#define		MP3_DREQ	1

#define		LED			3	// PORTD

#define		POWER		3	// PORTC
#define		BATT_VOLT	0	// PORTC drd

#define		RXD			0	// PORTD
#define		TXD			1
#define		ROM_CS		2

#define		SCL			5	// PORTC
#define		SDA			4

#define		PB7			7	// PORTB
#define		PB6			6

// XCb`̕rbg
#define		SW_PORT_START	4	// PIND
#define		SW_PORT_STOP	4	// == SW_PORT_START
#define		SW_PORT_REW		5	// PIND
#define		SW_PORT_VOLUP	6	// PIND
#define		SW_PORT_VOLDOWN	7	// PIND


// MMC CSM蓖
#define		MMC_MISO	4	// PORTB
#define		MMC_MOSI	3
#define		MMC_SCK		5

#define		MMC_CS_PORT	PORTB
#define		MMC_CS_DDR	DDRB
#define		MMC_CS		2

#define		MMC_CS_ON	MMC_CS_PORT &= ~(1<<MMC_CS)
#define		MMC_CS_OFF	MMC_CS_PORT |= (1<<MMC_CS)

#define		EEPROM_FIRM_TIMESTAMP	(uint32_t *)1

// MakefilẽJIvV̎w
// -Ttext=0x3800,--section-start=.bootsub=0x3400
// ɂA
// ADRS3400H w肵֐ 0x3400`
// ȊO 0x3800`̃u[g̈ɔzu
// ZtvOɕKvȊ֐̓u[g̈ɔzu邱
// ȂAPROGMEMȂǂ̒萔`̓u[g̈ɔzu

#define ADRS3400H	__attribute__ ((section (".bootsub")))

uchar SPI_in(void);
void SPI_out(uchar data);
uchar SPI_command(uchar com, ulong arg);

uchar read_VFAT_info(void);
uchar read_32(ulong addr, uchar *buff);

uchar mmc_read(ulong addr);
uchar mmc_init(void);

ulong cluster_to_adrs(uint cluster);
uint next_cluster(uint c);
uint read_word(ulong addr);

void open_file(struct DIRECTORY *dir, struct FILE_DATA *fd);
void next_sector(struct FILE_DATA *fd);
uchar check_file(struct DIRECTORY *dir);
uchar search_file(struct DIRECTORY *dir);

int main(void);

uchar spm_main(struct FILE_DATA *fd);
void boot(void);

